﻿import { AnyAction } from "redux";
import { isLoop, getCmd, getModel, loop, Loop } from "redux-loop";
//import { DataFilterAction, DataFilterState } from "./dataFilters/models";

type StateOrLoop<T, TAction extends AnyAction> = T | Loop<T, TAction>;

export default
    <TIn, TAction extends AnyAction, TOut>
    (stateOrLoop: StateOrLoop<TIn,TAction>, map: (i: TIn) => TOut) => (

    isLoop(stateOrLoop)

        ? loop(map(getModel(stateOrLoop)), getCmd(stateOrLoop)!)

        : (map(stateOrLoop as TIn)));
